% *** testing cross correlation using barker codes ***
% file: BarkerSimulation_1.m
% update: Oct 24th, 2014

% Function needed in MatLab in extra file 'crossm.m':

%%sssssssssssssssssssssss
% function [Rxy]=crossm(x,y)
% % This function Estimates the crosscorrelation of the sequence x and y
% N=length(x);
% Rxy=zeros(1,N);
% for m=1: N+1
	% for n=1: N-m+1
	% Rxy(m)=Rxy(m)+x(n)*y(n+m-1);
	% end;
% end;
%%eeeeeeeeeeeeeeeeeeeeeeee

clear;

N=200; % Number of samples to generate
delay_tx_rx=50;

noise_amplitude=0;
%noise_amplitude=2;

line_attenuation=50; % Tx/Rx line attenuation [dB]

x=zeros(1,N);
%barker=[1,1,1,0,0,1,0];  % 7 bit barker code
%barker=[1,1,1,0,0,0,1,0,0,1,0];  % 11 bit barker code
barker=[1,1,1,1,1,0,0,1,1,0,1,0,1];  % 13 bit barker code

x(1:length(barker))=5*barker;
subplot(3,1,1);
stairs(x);
title('Transmitted signal');
ylim([0,7]);
xlabel('[usec]');
ylabel('[dB]');
grid();

xd=[zeros(1,delay_tx_rx), x(1:N-delay_tx_rx)];  % signal delay
xd=0.7*xd(1:N);   % signal attenuation

w=noise_amplitude*randn(1,N);   % create noise signal

r=xd+w;	% create the sum signal
subplot(3,1,2);
plot(r-50);
title('Received signal');
xlabel('[usec]');
ylim([-60,-40]);
ylabel('[dB]');
grid();

Rxy=crossm(x,r); % Estimate the cross correlation
Rxy=Rxy/max(Rxy);
subplot(3,1,3);
plot(Rxy);
title('Cross correlation transmit receive');
xlabel('[usec]');
ylim([0,1]);
grid;

disp('maximum found at sample : ');
disp(find(Rxy==max(Rxy)));







