%% Main program of closed loop radar application
% To be used to record and playback radar signals. 
% The functions can be used separately

%% EXTERNAL REFERENCE =====================================================
% External reference needs to be supplied to FSx in order to perform
% IQ measurement without tracking the signal.
% make sure to connect SMBV's  reference output to FSx input
%% ========================================================================

%smbvID = 'smbv100a258082';
%smbvID = 'rssmw200a101101';
%smxID = 'smbv100a258082';
smxID = 'rssmu200a100951';
%fsxID = 'fsv7-102622';
fsxID = 'fsvr7-100842';

fileName = 'rRecord.csv';

global settings;
settings.frequency = '2.45GHz';
settings.level = '-30dBm';
settings.numPoints = 1000;       % needs to be a multiple of 100.


% if data is recorded, predefined pattern will be overwritten
pattern = [0 0 0 0 0 1 1 0 0 1 0 1 0];

%% play the extracted pattern using an SMBV
% smbvID    Hostname or IP adress of signal generator
% pattern   patterm to be PSK modulated on RF
Setup_SMx(smxID, pattern);

%% setup analogue Phase demod measurement with R&S spectrum analyzer
% fsxID     Hostname or IP adress of spectrum analyzer
Setup_FSx(fsxID);

%% record data using FSx
% fsxID     Hostname or IP adress of specrum analzyer
% fileName  select a '.dat' file to analyze
TraceFile(fsxID, fileName);

%% extract bit pattern from  recorded data
% fsxID     Hostname or IP adress of specrum analyzer
% fileName  select a '.dat' file to analyze
pattern = Get_Bits(fsxID, fileName, pattern);
