function TraceFile( fsxID, fileName )
%% TraceFile is used to read receive trace data from 
% R&S spectrum analyzer and convert it into MATLAB compatible
% format. 
% The file as <RadarRecord.dat> is stored in the current directory

global settings;

[~, deviceObj] = rs_connect('tcpip', fsxID);

rs_send_command(deviceObj, 'FORMAT ASC');      %ASCii Format
rs_send_query(deviceObj, '*OPC?');

traceY = [];
for num=0 : (settings.numPoints-100)/100
    [~, charStrY] = rs_send_query(deviceObj, ['TRACe1:MEM? TRACE1, ', num2str(num*100+1), ', 100']);
    rs_send_query(deviceObj, '*OPC?');
    traceY=[traceY str2num(charStrY)];
end

traceX = 1:length(traceY);

csvwrite(fileName, [traceX' traceY']);

% export .dat file
rs_send_command(deviceObj, ['MMEM:STOR:TRACE 1,''C:\\R_S\instr\user\' fileName '''']);  % save on disk
rs_send_query(deviceObj, '*OPC?');

